# action-test-runner

This Action try to generalize the way in which you can start tests.
It aim to provide common dependencies for test environment like KinD, Bats and the like

## Requirement

This actions require all the tests in the target repo to be callable using `task test` as entry point, levering [taskfile](taskfile.dev)

The other minimal entrypoints required are

- `task test`
- `task test:clean`
- `task test:logs`

## Inputs

### Required

- `github_token`: GITHUB_TOKEN secret

## Optional

- `artifactory_username`: Artifactory Username
- `artifactory_password`: Artifactory Password
- `kind_needed`: Boolean if a Kubernetes In Docker cluster is needed for tests (default: false)
- `kind_version`: KinD version (default: "v0.11.1")
- `kind_config_path`: Kind config path (default: tests/kind-config.yaml)
- `kind_cluster_name`: Kind cluster name (default: kind)
- `bats_version`: BATS version ("1.5.0")
- `envsubst_needed`: Indicate if envsubst is needed (default: "false")

## Example workflow

Perform all checks on pull requests

```yaml
name: tests

on:

  pull_request:
    types: [opened, review_requested, ready_for_review]

jobs:
  tests:
    runs-on: self-hosted
    steps:
      - uses: actions/checkout@v2
      - uses: draios/infra-action-test-runner@v1
        with:
          github_token: ${{ secrets.GITHUB_TOKEN }}
          # this will trigger `task test` in the target repo
```
